<?xml version="1.0"?>
<!--
	RELAX NG Shorthand Processor
	$Id: ShortRNG.xsl,v 1.0 2001-08-16 12:42:21-07 bear Exp bear $
                      Copyright (C) 2001, Kohsuke KAWAGUCHI
                         e-mail: kohsukekawaguchi@yahoo.com
-->
<x:stylesheet
	xmlns:x="http://www.w3.org/1999/XSL/Transform"
	xmlns="http://relaxng.org/ns/structure/0.9"
	xmlns:s="http://relaxng.sourceforge.net/ns/shorthand"
	version="1.0">
	
	<x:output encoding="utf-8" indent="yes"/>
	
	<!-- pattern with @occurs -->
	<x:template match="s:*[@occurs]">
		<x:choose>
			<x:when test="@occurs='?'">
				<optional>
					<x:apply-templates select="." mode="pass2"/>
				</optional>
			</x:when>
			<x:when test="@occurs='+'">
				<oneOrMore>
					<x:apply-templates select="." mode="pass2"/>
				</oneOrMore>
			</x:when>
			<x:when test="@occurs='*'">
				<zeroOrMore>
					<x:apply-templates select="." mode="pass2"/>
				</zeroOrMore>
			</x:when>
			<x:otherwise>
				<x:message terminate="yes">
					Unknown occurs type: <x:value-of select="@occurs"/>
				</x:message>
			</x:otherwise>
		</x:choose>
	</x:template>
	<x:template match="s:*">
		<x:apply-templates select="." mode="pass2"/>
	</x:template>
	
	
	<!-- attribute with @type -->
	<x:template match="s:attribute[@type]" mode="pass2">
		<attribute>
			<x:apply-templates select="@*|*|text()|comment()" mode="pass3"/>
			<data type="{@type}"/>
		</attribute>
	</x:template>
	<x:template match="s:*" mode="pass2">
		<x:apply-templates select="." mode="pass3"/>
	</x:template>
	<!-- ignore @type of the attribute -->
	<x:template match="s:attribute/@type" mode="pass3"/>
	<!-- default element processing rule -->
	<x:template match="s:*" mode="pass3">
		<x:element name="{local-name(.)}"><x:apply-templates select="*|@*|text()|comment()"/></x:element>
	</x:template>
	
	
	<!-- ignore @occurs -->
	<x:template match="@occurs"/>
	<!-- default rule -->
	<x:template match="*|@*|comment()|text()">
		<x:copy>
			<x:apply-templates select="*|@*|text()|comment()"/>
		</x:copy>
	</x:template>
	<x:template match="*|@*|comment()|text()" mode="pass3">
		<x:copy>
			<x:apply-templates select="*|@*|text()|comment()"/>
		</x:copy>
	</x:template>
	
</x:stylesheet>
